Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.fasterxml.jackson.databind.deser.std
Class DelegatingDeserializer

    java.lang.Object
      com.fasterxml.jackson.databind.JsonDeserializer<T>
          com.fasterxml.jackson.databind.deser.std.StdDeserializer<Object>
              com.fasterxml.jackson.databind.deser.std.DelegatingDeserializer

All Implemented Interfaces:
  ContextualDeserializer, ResolvableDeserializer, Serializable

    public abstract class DelegatingDeserializer

extends StdDeserializer<Object>
implements ContextualDeserializer, ResolvableDeserializer

Base class that simplifies implementations of `JsonDeserializer`s that mostly delegate functionality to another deserializer implementation (possibly forming a chaing of deserializers delegating functionality in some cases)

Since:
  2.1
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer
`JsonDeserializer.None`

Field Summary
`protected JsonDeserializer<?>` | `_delegatee`

Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer
`_valueClass`

Constructor Summary
`DelegatingDeserializer(JsonDeserializer<?> delegatee)`

Method Summary
`protected JsonDeserializer<?>` | `_createContextual(DeserializationContext ctxt, BeanProperty property, JsonDeserializer<?> newDelegatee)`
`JsonDeserializer<?>` | `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
`Object` | `deserialize(JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`Object` | `deserialize(JsonParser jp, DeserializationContext ctxt, Object intoValue)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
`Object` | `deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
`JsonDeserializer<?>` | `getDelegatee()` Accessor that can be used to determine if this deserializer uses another deserializer for actual deserialization, by delegating calls.
`Object` | `getEmptyValue()` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).
`Collection<Object>` | `getKnownPropertyNames()` Method that will either return null to indicate that type being deserializers has no concept of properties; or a collection of identifiers for which `toString` will give external property name.
`Object` | `getNullValue()` Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`).
`ObjectIdReader` | `getObjectIdReader()` Accessor that can be used to check whether this deserializer is expecting to possibly get an Object Identifier value instead of full value serialization, and if so, should be able to resolve it to actual Object instance to return as deserialized value.
`boolean` | `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).
`protected abstract JsonDeserializer<?>` | `newDelegatingInstance(JsonDeserializer<?> newDelegatee)`
`JsonDeserializer<?>` | `replaceDelegatee(JsonDeserializer<?> delegatee)` Method that can be called to try to replace deserializer this deserializer delegates calls to.
`void` | `resolve(DeserializationContext ctxt)` Method called after deserializer instance has been constructed (and registered as necessary by provider objects), but before it has returned it to the caller.

Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer
`_parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findDeserializer, getValueClass, getValueType, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer
`unwrappingDeserializer`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _delegatee

    protected final JsonDeserializer<?> _delegatee

Constructor Detail

### DelegatingDeserializer

    public DelegatingDeserializer(JsonDeserializer<?> delegatee)

Method Detail

### newDelegatingInstance

    protected abstract JsonDeserializer<?> newDelegatingInstance(JsonDeserializer<?> newDelegatee)

### resolve

    public void resolve(DeserializationContext ctxt)
                 throws JsonMappingException

  Description copied from interface: `ResolvableDeserializer`
  Method called after deserializer instance has been constructed (and registered as necessary by provider objects), but before it has returned it to the caller. Called object can then resolve its dependencies to other types, including self-references (direct or indirect).

  Specified by:
    `resolve` in interface `ResolvableDeserializer`
  Parameters:
    `ctxt` - Context to use for accessing configuration, resolving secondary deserializers
  Throws:
    `JsonMappingException`

### createContextual

    public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                                BeanProperty property)
                                         throws JsonMappingException

  Description copied from interface: `ContextualDeserializer`
  Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

  Specified by:
    `createContextual` in interface `ContextualDeserializer`
  Parameters:
    `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
    `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
  Returns:
    Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
  Throws:
    `JsonMappingException`

### _createContextual

    protected JsonDeserializer<?> _createContextual(DeserializationContext ctxt,
                                                    BeanProperty property,
                                                    JsonDeserializer<?> newDelegatee)

### deserialize

    public Object deserialize(JsonParser jp,
                              DeserializationContext ctxt)
                       throws IOException,
                              JsonProcessingException

  Description copied from class: `JsonDeserializer`
  Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

  Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

  Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

  Specified by:
    `deserialize` in class `JsonDeserializer<Object>`
  Parameters:
    `jp` - Parsed used for reading JSON content
    `ctxt` - Context that can be used to access information about this deserialization activity.
  Returns:
    Deserializer value
  Throws:
    `IOException`
    `JsonProcessingException`

### deserialize

    public Object deserialize(JsonParser jp,
                              DeserializationContext ctxt,
                              Object intoValue)
                       throws IOException,
                              JsonProcessingException

  Description copied from class: `JsonDeserializer`
  Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used for all supported types; most commonly it is used for Collections and Maps.

  Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

  Overrides:
    `deserialize` in class `JsonDeserializer<Object>`
  Throws:
    `IOException`
    `JsonProcessingException`

### deserializeWithType

    public Object deserializeWithType(JsonParser jp,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer)
                               throws IOException,
                                      JsonProcessingException

  Description copied from class: `StdDeserializer`
  Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.

  Overrides:
    `deserializeWithType` in class `StdDeserializer<Object>`
    `typeDeserializer` - Deserializer to use for handling type information
  Throws:
    `IOException`
    `JsonProcessingException`

### replaceDelegatee

    public JsonDeserializer<?> replaceDelegatee(JsonDeserializer<?> delegatee)

  Description copied from class: `JsonDeserializer`
  Method that can be called to try to replace deserializer this deserializer delegates calls to. If not supported (either this deserializer does not delegate anything; or it does not want any changes), should either throw `UnsupportedOperationException` (if operation does not make sense or is not allowed); or return this deserializer as is.

  Overrides:
    `replaceDelegatee` in class `JsonDeserializer<Object>`

### getNullValue

    public Object getNullValue()

  Description copied from class: `JsonDeserializer`
  Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`). Usually this is simply Java null, but for some types (especially primitives) it may be necessary to use non-null values.

  Note that deserializers are allowed to call this just once and then reuse returned value; that is, method is not guaranteed to be called once for each conversion.

  Default implementation simply returns null.

  Overrides:
    `getNullValue` in class `JsonDeserializer<Object>`

### getEmptyValue

    public Object getEmptyValue()

  Description copied from class: `JsonDeserializer`
  Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `JsonDeserializer.getNullValue()` (which in turn is usually simply Java null), but it can be overridden for types. Or, if type should never be converted from empty String, method can also throw an exception.

  Default implementation simple calls `JsonDeserializer.getNullValue()` and returns value.

  Overrides:
    `getEmptyValue` in class `JsonDeserializer<Object>`

### getKnownPropertyNames

    public Collection<Object> getKnownPropertyNames()

  Description copied from class: `JsonDeserializer`
  Method that will either return null to indicate that type being deserializers has no concept of properties; or a collection of identifiers for which `toString` will give external property name. This is only to be used for error reporting and diagnostics purposes (most commonly, to accompany "unknown property" exception).

  Overrides:
    `getKnownPropertyNames` in class `JsonDeserializer<Object>`

### isCachable

    public boolean isCachable()

  Description copied from class: `JsonDeserializer`
  Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

  Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

  Default implementation returns false, to indicate that no caching is done.

  Overrides:
    `isCachable` in class `JsonDeserializer<Object>`

### getObjectIdReader

    public ObjectIdReader getObjectIdReader()

  Description copied from class: `JsonDeserializer`
  Accessor that can be used to check whether this deserializer is expecting to possibly get an Object Identifier value instead of full value serialization, and if so, should be able to resolve it to actual Object instance to return as deserialized value.

  Default implementation returns null, as support can not be implemented generically. Some standard deserializers (most notably `BeanDeserializer`) do implement this feature, and may return reader instance, depending on exact configuration of instance (which is based on type, and referring property).

  Overrides:
    `getObjectIdReader` in class `JsonDeserializer<Object>`
  Returns:
    ObjectIdReader used for resolving possible Object Identifier value, instead of full value serialization, if deserializer can do that; null if no Object Id is expected.

### getDelegatee

    public JsonDeserializer<?> getDelegatee()

  Description copied from class: `JsonDeserializer`
  Accessor that can be used to determine if this deserializer uses another deserializer for actual deserialization, by delegating calls. If so, will return immediate delegate (which itself may delegate to further deserializers); otherwise will return null.

  Overrides:
    `getDelegatee` in class `JsonDeserializer<Object>`
  Returns:
    Deserializer this deserializer delegates calls to, if null; null otherwise.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2012 FasterXML. All Rights Reserved.